DROP TABLE IF EXISTS LANG;
DROP TABLE IF EXISTS VERS;
DROP TABLE IF EXISTS POS;
DROP TABLE IF EXISTS TYPE;
DROP TABLE IF EXISTS XREF_TYPE;
DROP TABLE IF EXISTS LABEL;
DROP TABLE IF EXISTS SYNTAX;
DROP TABLE IF EXISTS DESCRIPTION;
DROP TABLE IF EXISTS XREF;
DROP TABLE IF EXISTS EXAMPLE;
DROP TABLE IF EXISTS COMMAND_TYPE;
DROP TABLE IF EXISTS COMMAND;


CREATE TABLE LANG (
         LANG_ID SMALLINT NOT NULL /* AUTO_INCREMENT */,
	 NAME VARCHAR(10) BINARY NOT NULL,
         DIR CHAR(3) NOT NULL,
	 DESCRIPTION VARCHAR(80) BINARY NOT NULL,

	 CONSTRAINT PK_LANG PRIMARY KEY(LANG_ID),
	 CONSTRAINT UK_LANG_NAME UNIQUE(NAME),
         CONSTRAINT UK_LANG_DIR UNIQUE(DIR)
);

INSERT INTO LANG(LANG_ID, NAME, DIR, DESCRIPTION) VALUES (1, 'german',  'ger', 'German');

INSERT INTO LANG(LANG_ID, NAME, DIR, DESCRIPTION) VALUES (2, 'english', 'eng', 'English');

INSERT INTO LANG(LANG_ID, NAME, DIR, DESCRIPTION) VALUES (3, 'dutch',   'dut', 'Dutch');

INSERT INTO LANG(LANG_ID, NAME, DIR, DESCRIPTION) VALUES (4, 'french',  'fre', 'French');

INSERT INTO LANG(LANG_ID, NAME, DIR, DESCRIPTION) VALUES (5, 'italian', 'ita', 'Italian');

INSERT INTO LANG(LANG_ID, NAME, DIR, DESCRIPTION) VALUES (6, 'spanish', 'spa', 'Spanish');

INSERT INTO LANG(LANG_ID, NAME, DIR, DESCRIPTION) VALUES (7, 'swedish', 'swe', 'Swedish');



CREATE TABLE VERS (
         VERS_ID SMALLINT NOT NULL /* AUTO_INCREMENT */,
         VERS VARCHAR(80) BINARY NOT NULL,
         OFFICIAL_RELEASE CHAR(1) BINARY NOT NULL,
         RELEASE_DATE DATE,

         CONSTRAINT PK_VERSION PRIMARY KEY(VERS_ID),
         CONSTRAINT UK_VERSION_VERS UNIQUE(VERS)
);

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(0, 'Initial version', 'Y', '0000-00-00');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(1, 'Release 3', 'Y', '1994-01-01');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(2, 'Release 4', 'Y', '1995-11-12');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(3, 'Release 4 Version 0.37', 'N', '1995-12-22');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(4, 'Release 4 Version 0.38', 'N', '1995-12-27');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(5, 'Release 4 Version 0.39', 'N', '1996-01-06');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(6, 'Release 4 Version 0.40', 'N', '1996-01-20');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(7, 'Release 4 Version 0.41', 'N', '1996-01-24');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(8, 'Release 4 Version 0.42', 'N', '1996-01-25');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(9, 'Release 4 Version 0.43', 'N', '1996-02-11');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(10, 'Release 4 Version 0.44', 'N', '1996-02-23');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(11, 'Release 4 Version 0.45', 'N', '1996-03-02');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(12, 'Release 4 Version 0.46', 'N', '1996-03-11');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(13, 'Release 4 Version 0.47', 'N', '1996-03-27');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(14, 'Release 4 Version 0.48', 'N', '1996-04-08');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(15, 'Release 5', 'Y', '1996-04-18');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(16, 'Release 5 Version 0.49', 'N', '1996-04-28');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(17, 'Release 5 Patchlevel 2', 'N', '1996-05-19');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(18, 'Release 5 Patchlevel 3', 'N', '1996-05-22');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(19, 'Release 5 Patchlevel 4', 'N', '1996-05-31');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(20, 'Release 5 Patchlevel 5', 'N', '1996-06-31');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(21, 'Release 5 Patchlevel 6', 'N', '1996-07-17');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(22, 'Release 5 Patchlevel 7', 'N', '1996-07-29');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(23, 'Release 5 Patchlevel 8', 'N', '1996-08-08');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(24, 'Release 5 Patchlevel 9', 'N', '1996-08-17');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(25, 'Release 5 Patchlevel 10', 'N', '1996-08-27');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(26, 'Release 5 Patchlevel 11', 'N', '1996-09-17');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(27, 'Release 5 Patchlevel 12', 'N', '1996-10-04');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(28, 'Release 5 Patchlevel 13', 'N', '1996-10-13');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(29, 'Release 5 Patchlevel 14', 'N', '1996-11-16');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(30, 'Release 5 Patchlevel 15', 'N', '1996-11-29');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(31, 'Release 5 Patchlevel 16', 'N', '1996-12-14');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(32, 'Release 6', 'Y', '1997-01-02');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(33, 'Release 6 Patchlevel 0', 'N', '1997-01-02');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(34, 'Release 6 Patchlevel 1', 'N', '1997-02-10');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(35, 'Release 6 Patchlevel 2', 'N', '1997-03-26');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(36, 'Release 6 Patchlevel 3', 'N', '1997-04-04');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(37, 'Release 6 Patchlevel 4', 'N', '1997-06-25');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(38, 'Release 6 Patchlevel 5', 'N', '1997-08-01');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(39, 'Release 6 Patchlevel 6', 'N', '1997-10-23');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(40, 'Release 6 Patchlevel 7', 'N', '1997-12-11');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(41, 'Release 6 Patchlevel 8', 'N', '1998-04-03');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(42, 'Release 6 Patchlevel 9', 'N', '1998-04-16');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(43, 'Release 6 Patchlevel 10', 'N', '1998-04-29');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(44, 'Release 6 Patchlevel 11', 'N', '1998-07-23');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(45, 'Release 6 Patchlevel 12', 'N', '1999-01-08');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(46, 'Release 6 Patchlevel 13', 'N', '1999-07-10');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(47, 'Release 6 Patchlevel 14', 'N', '1999-07-22');

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(48, 'Release 6 Patchlevel 15', 'N', NULL);

INSERT INTO VERS(VERS_ID, VERS, OFFICIAL_RELEASE, RELEASE_DATE) VALUES(49, 'Release 7', 'Y', NULL);




CREATE TABLE COMMAND_TYPE (
	COMMAND_TYPE CHAR(1) BINARY NOT NULL,
	DESCRIPTION VARCHAR(80) BINARY,

	CONSTRAINT PK_COMMAND_TYPE PRIMARY KEY(COMMAND_TYPE)
);

INSERT INTO COMMAND_TYPE (COMMAND_TYPE, DESCRIPTION) VALUES('S', 'special');

INSERT INTO COMMAND_TYPE (COMMAND_TYPE, DESCRIPTION) VALUES('D', 'dotted');

INSERT INTO COMMAND_TYPE (COMMAND_TYPE, DESCRIPTION) VALUES('B', 'bracketed');

INSERT INTO COMMAND_TYPE (COMMAND_TYPE, DESCRIPTION) VALUES('1', 'single char');

INSERT INTO COMMAND_TYPE (COMMAND_TYPE, DESCRIPTION) VALUES('Q', 'no quote');

INSERT INTO COMMAND_TYPE (COMMAND_TYPE, DESCRIPTION) VALUES('N', 'normal');



CREATE TABLE TYPE (
	TYPE CHAR(1) BINARY NOT NULL,
	LANG_ID SMALLINT NOT NULL,
	DESCRIPTION VARCHAR(80) BINARY,

	CONSTRAINT PK_TYPE PRIMARY KEY(TYPE, LANG_ID),
	CONSTRAINT FK_TYPE_LANG_ID FOREIGN KEY (LANG_ID)
	   REFERENCES LANG(LANG_ID)
);

INSERT INTO TYPE (TYPE, LANG_ID, DESCRIPTION) VALUES('S', 1, 'Sonderzeichen');

INSERT INTO TYPE (TYPE, LANG_ID, DESCRIPTION) VALUES('C', 1, 'Kommando');

INSERT INTO TYPE (TYPE, LANG_ID, DESCRIPTION) VALUES('A', 1, 'Kommando-Abkrzung');

INSERT INTO TYPE (TYPE, LANG_ID, DESCRIPTION) VALUES('P', 1, 'Platzhalter');

INSERT INTO TYPE (TYPE, LANG_ID, DESCRIPTION) VALUES('W', 1, 'Schalter');

INSERT INTO TYPE (TYPE, LANG_ID, DESCRIPTION) VALUES('S', 2, 'special characters');

INSERT INTO TYPE (TYPE, LANG_ID, DESCRIPTION) VALUES('C', 2, 'command');

INSERT INTO TYPE (TYPE, LANG_ID, DESCRIPTION) VALUES('A', 2, 'command abbreviation');

INSERT INTO TYPE (TYPE, LANG_ID, DESCRIPTION) VALUES('P', 2, 'placeholder');

INSERT INTO TYPE (TYPE, LANG_ID, DESCRIPTION) VALUES('W', 2, 'switch');



CREATE TABLE POS (
	POS CHAR(1) BINARY NOT NULL,
	LANG_ID SMALLINT NOT NULL,
	DESCRIPTION VARCHAR(80) BINARY,

	CONSTRAINT PK_POS PRIMARY KEY(POS, LANG_ID),
	CONSTRAINT FK_POS_LANG_ID FOREIGN KEY (LANG_ID)
	   REFERENCES LANG(LANG_ID)
);

INSERT INTO POS (POS, LANG_ID, DESCRIPTION) VALUES('P', 1, 'Vorspann');

INSERT INTO POS (POS, LANG_ID, DESCRIPTION) VALUES('M', 1, 'Hauptteil');

INSERT INTO POS (POS, LANG_ID, DESCRIPTION) VALUES('B', 1, 'Vorspann & Hauptteil');

INSERT INTO POS (POS, LANG_ID, DESCRIPTION) VALUES('P', 2, 'preamble');

INSERT INTO POS (POS, LANG_ID, DESCRIPTION) VALUES('M', 2, 'main part');

INSERT INTO POS (POS, LANG_ID, DESCRIPTION) VALUES('B', 2, 'preamble & main part');




CREATE TABLE COMMAND (
        COMMAND_ID SMALLINT NOT NULL /* AUTO_INCREMENT */,
        COMMAND VARCHAR(30) BINARY NOT NULL,
	COMMAND_TYPE CHAR(1) BINARY NOT NULL,
	TYPE CHAR(1) BINARY NOT NULL,
	POS CHAR(1) BINARY NOT NULL,
        FILENAME VARCHAR(40) NOT NULL,
        EXISTS_SINCE SMALLINT NOT NULL,
        EXISTED_UNTIL SMALLINT NOT NULL,
        SORT CHAR(1) BINARY NOT NULL,

	CONSTRAINT PK_COMMAND PRIMARY KEY(COMMAND_ID),
	CONSTRAINT UK_COMMAND_ID UNIQUE(COMMAND_ID, COMMAND_TYPE),
        CONSTRAINT UK_COMMAND_FILENAME UNIQUE(FILENAME),
        CONSTRAINT FK_COMMAND_EXISTS_SINCE FOREIGN KEY (EXISTS_SINCE)
           REFERENCES VERS(VERS_ID),
        CONSTRAINT FK_COMMAND_EXISTED_UNTIL FOREIGN KEY (EXISTED_UNTIL)
           REFERENCES VERS(VERS_ID),
        CONSTRAINT FK_COMMAND_COMMAND_TYPE FOREIGN KEY (COMMAND_TYPE)
           REFERENCES COMMAND_TYPE(COMMAND_TYPE),
        CONSTRAINT FK_COMMAND_TYPE FOREIGN KEY(TYPE)
           REFERENCES TYPE(TYPE),
        CONSTRAINT FK_COMMAND_POS FOREIGN KEY(POS)
           REFERENCES POS(POS)
);


CREATE TABLE SYNTAX (
        SYNTAX_ID SMALLINT NOT NULL /* AUTO_INCREMENT */,
	COMMAND_ID SMALLINT NOT NULL,
        LANG_ID SMALLINT DEFAULT 2 NOT NULL,
	SYNTAX VARCHAR(80) BINARY NOT NULL,

	CONSTRAINT PK_SYNTAX PRIMARY KEY(SYNTAX_ID),
	CONSTRAINT FK_SYNTAX_LANG_ID FOREIGN KEY (LANG_ID)
	   REFERENCES LANG(LANG_ID),
        CONSTRAINT FK_SYNTAX_COMMAND_ID FOREIGN KEY (COMMAND_ID)
	    REFERENCES COMMAND(COMMAND_ID)
);



CREATE TABLE DESCRIPTION (
	 DESCRIPTION_ID SMALLINT NOT NULL /* AUTO_INCREMENT */,
	 COMMAND_ID SMALLINT NOT NULL,
	 LANG_ID SMALLINT DEFAULT 2 NOT NULL,
	 LINE SMALLINT NOT NULL,
	 DESCRIPTION VARCHAR(200) BINARY,

	 CONSTRAINT PK_DESCRIPTION PRIMARY KEY(DESCRIPTION_ID),
         CONSTRAINT UK_DESCRIPTION_LINE UNIQUE(COMMAND_ID, LANG_ID, LINE),
	 CONSTRAINT FK_DESCRIPTION_LANG_ID FOREIGN KEY (LANG_ID)
	    REFERENCES LANG(LANG_ID),
	 CONSTRAINT FK_DESCRIPTION_COMMAND_ID FOREIGN KEY (COMMAND_ID)
	    REFERENCES COMMAND(COMMAND_ID)
);



CREATE TABLE EXAMPLE (
	 EXAMPLE_ID SMALLINT NOT NULL /* AUTO_INCREMENT */,
	 COMMAND_ID SMALLINT NOT NULL,
	 LANG_ID SMALLINT DEFAULT 2 NOT NULL,
	 LINE SMALLINT NOT NULL,
	 EXAMPLE VARCHAR(80) BINARY,

	 CONSTRAINT PK_EXAMPLE PRIMARY KEY(EXAMPLE_ID),
         CONSTRAINT UK_EXAMPLE_LINE UNIQUE(COMMAND_ID, LANG_ID, LINE),
	 CONSTRAINT FK_EXAMPLE_LANG_ID FOREIGN KEY (LANG_ID)
	    REFERENCES LANG(LANG_ID),
	 CONSTRAINT FK_EXAMPLE_COMMAND_ID FOREIGN KEY (COMMAND_ID, LANG_ID)
	    REFERENCES COMMAND(COMMAND_ID, LANG_ID)
);



CREATE TABLE LABEL (
	 LABEL_ID SMALLINT NOT NULL /* AUTO_INCREMENT */,
	 COMMAND_ID SMALLINT NOT NULL,
	 LANG_ID SMALLINT DEFAULT 2 NOT NULL,
	 LINE SMALLINT NOT NULL,
	 LABEL VARCHAR(80) BINARY NOT NULL,

	 CONSTRAINT PK_LABEL PRIMARY KEY(LABEL_ID),
         CONSTRAINT UK_LABEL_LINE UNIQUE(COMMAND_ID, LANG_ID, LINE),
         CONSTRAINT UK_LABEL_LABEL UNIQUE(LANG_ID, LABEL),
	 CONSTRAINT FK_LABEL_LANG_ID FOREIGN KEY (LANG_ID)
	    REFERENCES LANG(LANG_ID),
	 CONSTRAINT FK_LABEL_COMMAND_ID FOREIGN KEY (COMMAND_ID)
	    REFERENCES COMMAND(COMMAND_ID)
);



CREATE TABLE XREF_TYPE (
         XREF_TYPE CHAR(1) BINARY NOT NULL,
	 DESCRIPTION VARCHAR(80) BINARY,

	 CONSTRAINT PK_XREF_TYPE PRIMARY KEY(XREF_TYPE)
);

INSERT INTO XREF_TYPE (XREF_TYPE, DESCRIPTION) VALUES ('L', 'link command');

INSERT INTO XREF_TYPE (XREF_TYPE, DESCRIPTION) VALUES ('A', 'link to label');

INSERT INTO XREF_TYPE (XREF_TYPE, DESCRIPTION) VALUES ('B', 'bracketed');

INSERT INTO XREF_TYPE (XREF_TYPE, DESCRIPTION) VALUES ('D', 'dotted');

INSERT INTO XREF_TYPE (XREF_TYPE, DESCRIPTION) VALUES ('N', 'normal');

INSERT INTO XREF_TYPE (XREF_TYPE, DESCRIPTION) VALUES ('1', 'single char');


CREATE TABLE XREF (
	 XREF_ID SMALLINT NOT NULL /* AUTO_INCREMENT */,
	 COMMAND_ID SMALLINT NOT NULL,
	 LANG_ID SMALLINT DEFAULT 2 NOT NULL,
	 LINE SMALLINT NOT NULL,
	 XREF VARCHAR(80) BINARY,
	 XREF_TYPE CHAR(1) BINARY NOT NULL,
	 XREF_TO SMALLINT,

	 CONSTRAINT PK_XREF PRIMARY KEY(XREF_ID),
         CONSTRAINT UK_XREF_LINE UNIQUE(COMMAND_ID, LANG_ID, LINE),
	 CONSTRAINT FK_XREF_LANG_ID FOREIGN KEY (LANG_ID)
	    REFERENCES LANG(LANG_ID),
	 CONSTRAINT FK_XREF_COMMAND_ID FOREIGN KEY (COMMAND_ID)
	    REFERENCES COMMAND(COMMAND_ID),
	 CONSTRAINT FK_XREF_XREF_TO FOREIGN KEY (COMMAND_ID)
	    REFERENCES COMMAND(COMMAND_ID),
	 CONSTRAINT FK_XREF_XREF_TYPE FOREIGN KEY (XREF_TYPE)
	    REFERENCES XREF_TYPE(XREF_TYPE)
);
